defint a-z
#include "vbcompat.bi"
cls
declare function qpartition_linkedsh(array1() as ushort, array2() as uinteger, theleft as integer, theright as integer, pivotIndex as integer) as integer
declare sub qsort_linkedsh(array1() as ushort, array2() as uinteger, byval theleft as integer, byval theright as integer, reverse_sort as integer)

dim mindate as integer: mindate = dateserial(1998, 10, 1)
dim uniqueuseramount as integer, scoreamount as integer, movieamount as integer

dim i as integer, j as integer, k as integer, m as integer, temp as uinteger

targetdir$ = "C:\testnetflix\dataset\"
open targetdir$ + "movieend.dat" for binary as #1: movieamount = (lof(1)-4)/4
dim shared movieend(0 to movieamount) as uinteger: get #1, 1, movieend(): close: print "Part 1 of 4 loaded. (movie sizes)"
open targetdir$ + "scores.dat" for binary as #1: scoreamount = lof(1)
dim shared rating_score(1 to scoreamount) as ubyte: get #1, 1, rating_score(): close: print "Part 2 of 4 loaded. (scores)"
open targetdir$ + "userids.dat" for binary as #1
dim shared rating_userid(1 to scoreamount) as uinteger: get #1, 1, rating_userid(): close: print "Part 3 of 4 loaded. (user ids per record)"


'get the amount of unique users
uniqueuseramount = 0
for i = 1 to scoreamount
if rating_userid(i) > uniqueuseramount then uniqueuseramount = rating_userid(i)
next i

open targetdir$ + "shortuserids.dat" for binary as #1
dim shared user_id(1 to uniqueuseramount) as uinteger: get #1, 1, user_id(): close #1: print "Part 4 of 4 loaded. (long user ids)"

'We need to convert rating_userid(), rating_score(), and movieend() into
'user_moviesrated(), user_moviesratedamount(), and user_moviesratedscore()

'First, go through once to find out how many movies there are per user:
dim shared user_moviesratedamount(1 to uniqueuseramount) as ushort
for i = 1 to scoreamount
user_moviesratedamount(rating_userid(i)) += 1
next i

'sort
dim shared user_id3(0 to uniqueuseramount) as uinteger
for i = 1 to uniqueuseramount: user_id3(i) = i: next i
dim shared user_id2(0 to uniqueuseramount) as uinteger
qsort_linkedsh user_moviesratedamount(), user_id3(), 1, uniqueuseramount, 1
print "User movie amounts sorted."



for i = 1 to uniqueuseramount: user_id2(user_id3(i)) = i: next i
for i = 1 to scoreamount
rating_userid(i) = user_id2(rating_userid(i))
next i
open targetdir$ + "userids2.dat" for output as #1: put #1, , rating_userid(): close #1


'clear user_id(1), 0, Len(user_id(1)) * Ubound(user_id)
dim shared testexists(1 to 2649429) as uinteger
for i = 1 to uniqueuseramount
testexists(user_id(i)) = user_id2(i)
next i

open targetdir$ + "shortuserids2.dat" for output as #1: put #1, , testexists(): close #1
erase user_id, user_id2, user_id3, testexists

'Now create user_moviesratedend().
'This is actually the start - 1, but later it becomes the end.
dim shared user_moviesratedend(0 to uniqueuseramount) as uinteger
temp = 0
for i = 1 to uniqueuseramount
user_moviesratedend(i) = temp
temp += user_moviesratedamount(i)
next i
erase user_moviesratedamount


'Get the movies and scores per user...
dim shared user_moviesrated(1 to scoreamount) as ushort
dim shared user_moviesratedscore(1 to scoreamount) as ubyte

for curmovie = 1 to movieamount
for i = movieend(curmovie-1) + 1 to movieend(curmovie)
curuser = rating_userid(i)
user_moviesratedend(curuser) += 1
curloc = user_moviesratedend(curuser)
user_moviesrated(curloc) = curmovie
user_moviesratedscore(curloc) = rating_score(i)
next i
next curmovie
print "Movies/scores per user loaded."



open targetdir$ + "userdata1.dat" for output as #1
put #1, , movieamount
put #1, , scoreamount
put #1, , uniqueuseramount
put #1, , user_moviesratedend()   'ends/sizes per user?
put #1, , user_moviesrated()      'which movies?
put #1, , user_moviesratedscore() 'what is their score?
close #1
print "Data is saved."
print
print "Done!"
sleep

system



function qpartition_linkedsh(array1() as ushort, array2() as uinteger, theleft as integer, theright as integer, pivotIndex as integer) as integer
dim pivotValue as typeof(array1)
dim as integer i, storeindex
pivotValue = array1(pivotIndex)
swap array1(pivotIndex), array1(theright) ' Move pivot to end
swap array2(pivotIndex), array2(theright)
storeIndex = theleft
for i = theleft to theright-1
if array1(i) <= pivotValue then
swap array1(storeIndex), array1(i)
swap array2(storeIndex), array2(i)
storeIndex = storeIndex + 1
end if
next i
swap array1(theright), array1(storeIndex) ' Move pivot to its final place
swap array2(theright), array2(storeIndex)
qpartition_linkedsh = storeIndex
end function


sub qsort_linkedsh(array1() as ushort, array2() as uinteger, byval theleft as integer, byval theright as integer, reverse_sort as integer)
dim temp1a as typeof(array1)
dim temp1b as typeof(array2)
dim as integer i, j, oldj, m, k, pivotamount, pivotindex, pivotnewindex, pbsize, therightmax, curpivot
dim as integer inileft, iniright
pbsize = (ubound(array1) - lbound(array1) + 1)\2
dim pivotleft(0 to pbsize) as integer, pivotright(0 to pbsize) as integer
pivotamount = 0
i = 0
inileft = theleft
iniright = theright
pivotleft(0) = theleft
pivotright(0) = theright
therightmax = theright
j = 1
do
oldj = j
do
if curpivot > pivotamount then exit do
m = curpivot+i
if m > pbsize then m = m - pbsize
theleft = pivotleft(m)
theright = pivotright(m)
if theright >= theleft then
pivotIndex = (theright-theleft)\2+theleft' int(RND*(theright-theleft))+theleft
pivotNewIndex = qpartition_linkedsh(array1(), array2(), theleft, theright, pivotIndex)
if j > pbsize then j = 0
pivotleft(j) = theleft: pivotright(j) = pivotNewIndex-1: j+=1
if j > pbsize then j = 0
pivotleft(j) = pivotNewIndex+1: pivotright(j) = theright: j+=1
k+=2
end if
curpivot+=1
loop
i = oldj
if i < 0 then i+=pbsize
pivotamount = k-1: k = 0
curpivot = 0
if pivotamount = -1 then exit do
loop


if reverse_sort = 1 then
for i = inileft to iniright \ 2
j = iniright - i + 1
swap array1(i), array1(j)
swap array2(i), array2(j)
next i
end if
end sub
