cls
randomize timer
declare function getRMSE(byval id1 as uinteger, byval id2 as uinteger) as integer
declare function getRMSE2(byval id1 as uinteger, byval id2 as uinteger) as uinteger
declare function partition_linkedi(array1() as uinteger, array2() as uinteger, theleft as integer, theright as integer, pivotIndex as integer) as integer
declare sub qsort_linkedi(array1() as uinteger, array2() as uinteger, byval theleft as integer, byval theright as integer, reverse_sort as integer)
declare sub qsort_linkedi2(array1() as uinteger, array2() as ubyte, byval theleft as integer, byval theright as integer, reverse_sort as integer, n as integer)
declare function existsinarray(ats() as ushort, byref value as ushort, byval first as integer, byval last as integer) as integer
declare sub adjustcats(n as integer)
const log2 = .6931471805599453

dim shared m2 as integer
dim shared uniqueuseramount as integer, scoreamount as integer, movieamount as integer
dim as integer biggestcommontot, biggestcommontotj
dim as uinteger totscores, curweight
dim as integer i, j, k, m, n, t3, k2
dim curmovie as ushort, ex1 as integer, temp as integer, seedtopfrac as single
dim shared totbins as integer
dim shared targetdir as string
dim matches2 as integer
dim shared as single t1, t2, toterror
dim as integer curmatches, curscore, iteration, iterationamount, maxerror, maxerror2
'Part 1: load the input data.
targetdir = "C:\testnetflix\dataset\"
open targetdir + "userdata1.dat" for binary as #1
get #1, , movieamount
get #1, , scoreamount
get #1, , uniqueuseramount
dim shared user_moviesratedend(0 to uniqueuseramount) as uinteger
dim shared user_moviesrated(1 to scoreamount) as ushort
dim shared user_moviesratedscore(1 to scoreamount) as ubyte
get #1, , user_moviesratedend()   'ends/sizes per user?
get #1, , user_moviesrated()      'which movies?
get #1, , user_moviesratedscore() 'what is their score?
close #1
print "Input data loaded. (Part 1 of 6)"

dim commontot(1 to movieamount, 1 to 5) as integer

'32/8192/8192/16-> 102
'256/8192/8192/16-> 103...

dim shared as integer binsize, usertestamount, totbinsize
dim as integer seedtop, sampletop, binusermax, alreadygenerated
dim as integer sizecatamount, sizecatamount2, curbin
dim as integer binuseramount, biniteration, binsizecat_end1, binsizecat_end2, tries, curuser
'Part 2: seed the categories.
'Declare the values we will use in other parts..
totbins = 32              'weights2 = 16/8192/512
binsize = 1000'610' 65536\2
usertestamount = uniqueuseramount'131072
totbinsize = totbins*binsize
seedtop = .1 * uniqueuseramount   'seed from top .1%
sampletop = 1 * uniqueuseramount 'sample from top 5%
binusermax = 12
alreadygenerated = 0
iterationamount = 10
'if alreadygenerated = 1 then goto skipit

dim shared catbin(1 to totbins, 1 to binsize) as uinteger


dim shared user_alreadyincompare(1 to binsize) as integer
dim shared user_alreadyinbin(1 to uniqueuseramount) as integer
dim shared user_alreadyintest(1 to uniqueuseramount) as integer
dim shared binuser(1 to binusermax) as integer
dim shared testuser(1 to usertestamount) as integer
dim shared user_moviesratedamount(1 to uniqueuseramount) as integer
dim shared acceptamountpertest(1 to binusermax) as integer
sizecatamount = 2
sizecatamount2 = uniqueuseramount\ sizecatamount
dim shared usersizecat(1 to uniqueuseramount) as integer
dim shared binsizecat(1 to totbins) as integer
dim shared usersizecat_end(0 to sizecatamount) as integer
dim shared do_skiptop4 as integer
dim shared RMSE(1 to usertestamount) as single
dim matches as uinteger, curRMSE as integer
dim shared binscore(1 to totbins, 1 to movieamount) as ubyte
dim shared tempbinscore(1 to movieamount) as integer
dim shared binscoretotal as integer, testexists as integer
dim shared umatches(1 to movieamount) as uinteger
dim shared userscore(1 to uniqueuseramount, 1 to totbins) as uinteger
dim shared userscore2(1 to totbins) as ubyte
dim shared curn(1 to totbins) as integer

do_skiptop4 = 2
if do_skiptop4 = 1 then adjustcats(do_skiptop4): goto skiptop4
if do_skiptop4 = 2 then adjustcats(do_skiptop4): goto skiptop4

j = 1
k = sizecatamount2
for i = 1 to uniqueuseramount
if i > k then usersizecat_end(j) = i: j+=1: k+=sizecatamount2
usersizecat(i) = j
next i

usersizecat_end(j-1) = uniqueuseramount
acceptamountpertest(1) = 2
acceptamountpertest(2) = 4
acceptamountpertest(3) = 8
acceptamountpertest(4) = 16
acceptamountpertest(5) = 26
acceptamountpertest(6) = 38
acceptamountpertest(7) = 42
acceptamountpertest(8) = 58
acceptamountpertest(9) = 72
acceptamountpertest(10) = 92
acceptamountpertest(11) = 114
acceptamountpertest(12) = 138

for i = 1 to uniqueuseramount
user_moviesratedamount(i) = user_moviesratedend(i) - user_moviesratedend(i-1)
next i

seedcategories:
k = 1
for i = 1 to totbins
j = int(rnd*seedtop) + 1
if user_alreadyinbin(j) <> 1 then user_alreadyinbin(j) = 1: catbin(k, 1) = j:binsizecat(k) = usersizecat(j): k+=1 else i-=1
next i

for i = 1 to uniqueuseramount: user_alreadyinbin(i) = 0: next i
print "Categories seeded. (Part 2 of 6)"

'Part 3: grow the categories.

'In 1/100ths. Eg: RMSE of 100 translates to an actual RMSE of 1.

'dim shared testorder(1 to uniqueuseramount) as integer
'for i = 1 to uniqueuseramount: testorder(i) = i: next i
'We grow each bin one at a time so we can re-use "usedusers()".
m = 0

for curbin = 1 to totbins
redobin: n = 0: binuseramount = 0: m+=1
user_alreadyinbin(catbin(curbin, 1)) = m


for biniteration = 2 to binsize
n+=1: locate 3, 5: print biniteration; "     ": locate 3, 10: print curbin;"     "

'Pick (a) user(s) from the bin:
'We don't want to pick the same user twice
if binuseramount < binusermax then binuseramount+=1
for j = 1 to binuseramount
pickbinuser: temp = int(rnd*(biniteration-1)) + 1
if user_alreadyincompare(temp) = 1 then goto pickbinuser
user_alreadyincompare(temp) = 1
binuser(j) = temp
next j
for j = 1 to binuseramount
user_alreadyincompare(binuser(j)) = 0
next j


'Get a test user, and:
'1: check that this test user is not already in our bin:
'2: check that it isn't in testing, either.
'3: check that it is in the same size category
'for i = 1 to usertestamount
'if i \ 1000 = i / 1000 then locate 3,25: print i;"  "
'picktestuser: 
''userstried(i) = int(rnd*seedtop) + 1
'binsizecat_end1 = usersizecat_end(binsizecat(curbin)-1)
'binsizecat_end2 = usersizecat_end(binsizecat(curbin))
'temp = binsizecat_end1 + 1 + INT(RND*(binsizecat_end2-binsizecat_end1-1))
'if user_alreadyinbin(temp) = m then goto picktestuser
'if user_alreadyintest(temp) = n then goto picktestuser
'user_alreadyintest(temp) = n
'testuser(i) = temp
'next i

'Compare bin users with test users...
matches2 = 0
for i = 1 to usertestamount
if user_alreadyinbin(i) = m then RMSE(i) = -1: continue for
RMSE(i) = 1: matches = 0
for j = 1 to binuseramount
curRMSE = getRMSE(catbin(curbin, binuser(j)), i)
'if curRMSE <> 2147483647 then RMSE(i) = RMSE(i) * curRMSE: matches+=1
if curRMSE <> 2147483647 then RMSE(i) = RMSE(i) + curRMSE^2: matches+=1
next j
'if matches = 0 then RMSE(i) = -1 else matches2 += 1: RMSE(i) = RMSE(i) ^ (1/matches)
if matches = 0 then RMSE(i) = -1 else matches2 += 1: RMSE(i) = sqr((RMSE(i)-1)/matches)
next i

if matches2 = 0 then j=-1: goto skipseed
j = 0
for i = 1 to usertestamount
if RMSE(i) <> -1 then j+=1: RMSE(j) = RMSE(i): testuser(j) = i
next i

qsort_linkedi RMSE(), testuser(), 1, j, 0

temp = acceptamountpertest(binuseramount)-1
if temp > binsize - biniteration then temp = binsize - biniteration
j = -1
for i = 0 to temp
if RMSE(i+1) = -1 then continue for 'safegard against empty RMSEs.
j+=1
k = biniteration+j
catbin(curbin, k) = testuser(i+1) 'Put in our result.
user_alreadyinbin(catbin(curbin, k)) = m
next i
skipseed:
biniteration+=j
if j = -1 then
tries+= 1
binuseramount-=1
else
tries = 0
end if
'reseed the category...
if tries = 5 then
binuseramount-=1
catbin(curbin, 1) = int(rnd*seedtop) + 1
binsizecat(curbin) = usersizecat(catbin(curbin, 1))
biniteration = 1
tries = 0
goto redobin
end if

next biniteration
next curbin

erase testuser, RMSE
print "Categories grown. (Part 3 of 6)"






'part 4
skiptop4:
for curbin = 1 to totbins
for i = 1 to binsize
curuser = catbin(curbin, i)
if curuser = 0 then continue for
for j = user_moviesratedend(curuser-1)+1 to user_moviesratedend(curuser)
curmovie = user_moviesrated(j)
curscore = user_moviesratedscore(j)
umatches(curmovie) +=1
commontot(curmovie, user_moviesratedscore(j))+= 1
next j, i

for curmovie = 1 to movieamount
curmatches = umatches(curmovie)
if curmatches > 10 then
biggestcommontot = commontot(curmovie, 1): biggestcommontotj = 1
for i = 2 to 5
if commontot(curmovie, i) > biggestcommontot then biggestcommontot = commontot(curmovie, i): biggestcommontotj = i
next i
binscore(curbin, curmovie) = biggestcommontotj
umatches(curmovie) = 0: tempbinscore(curmovie) = 0
end if
next curmovie
next curbin

binsize = uniqueuseramount/4 'the first binsize is smaller
redim catbin(1 to totbins, 1 to binsize) as uinteger



maxerror = 1300
for iteration = 1 to iterationamount
maxerror2 = maxerror*2
maxerror = 1300-iteration '1860-iteration*20
toterror = 0
totscores = 0

'Part 4b: try to get the lowest 4 top RMSE's for each user.

for curbin = 1 to totbins
locate 5,1: print curbin; "
for curuser = 1 to uniqueuseramount
userscore(curuser, curbin) = getRMSE2(curuser, curbin) 'Userscore is max(2^32-1) if there is no comparison possible.
next curuser
next curbin

for i = 1 to totbins: curn(i) = 0: next i
for curuser = 1 to uniqueuseramount
for j = 1 to totbins: userscore2(j) = j: next j
qsort_linkedi2 userscore(), userscore2(), 1, totbins, 0, curuser

'for j = 1 to totbins
'print userscore(curuser, j)
'next j
j = 8 'how many PER user (max?)
i = 0
do
i+=1
curbin = userscore2(i)
'should we control for repeat misses?
if curn(curbin) = binsize then
if j < totbins then j+=1: continue do else exit do   'try the next bin, making sure we don't go over the bin limit
end if

if userscore(curuser, i) > 2500 then exit do
'if userscore(curuser, i) = 4294967295 then exit do
'if userscore(curuser, i) > maxerror then exit do 'use a sliding scale...
toterror+=userscore(curuser, i)
totscores+=1
curn(curbin)+=1
catbin(curbin, curn(curbin)) = curuser
'print userscore(curuser, i)
if i = j then exit do
loop
'system
next curuser


for i = 1 to totbins: curn(i) = binsize: next i


for curbin = 1 to totbins
for i = 1 to movieamount
for j = 1 to 5: commontot(i, j) = 0: next j, i
if curn(curbin) = 0 then continue for
for i = 1 to curn(curbin)
curuser = catbin(curbin, i)
if curuser = 0 then continue for
'curweight = userscore(curuser, curbin)
'if curweight = 4294967295 then continue for
'curweight = ((6250000-curweight^2)/10000)^2/100
'if m2<100 then print curweight,userscore(curuser, curbin):m2+=1 else system
for j = user_moviesratedend(curuser-1)+1 to user_moviesratedend(curuser)
curmovie = user_moviesrated(j)
curscore = user_moviesratedscore(j)
umatches(curmovie) +=1
commontot(curmovie, user_moviesratedscore(j))+= maxerror2-userscore(curuser, curbin)
'commontot(curmovie, user_moviesratedscore(j))+= curweight
'print maxerror2,userscore(curuser, curbin)
'sleep
'system
next j, i

for curmovie = 1 to movieamount
curmatches = umatches(curmovie)
if curmatches > 5 then
biggestcommontot = commontot(curmovie, 1): biggestcommontotj = 1
for i = 2 to 5
if commontot(curmovie, i) > biggestcommontot then biggestcommontot = commontot(curmovie, i): biggestcommontotj = i
next i
binscore(curbin, curmovie) = biggestcommontotj
umatches(curmovie) = 0: tempbinscore(curmovie) = 0
end if
next curmovie
next curbin

locate 6,1: print iteration;"   "
locate 7,1: print toterror;"   "; totscores; "    "; toterror/totscores; "   "; m2; "       "
next iteration




print "Movies scored on categories. (Part 4 of 6)"
print "Bin scores per movie translated to user scores per bin. (Part 5 of 6)"
'Part 6: output the data

open targetdir + "weights.dat" for output as #1
put #1, , totbins
put #1, , binscore()
put #1, , userscore()
close #1

if do_skiptop4 = 0 then
open targetdir + "catbinweights1.dat" for output as #1
put #1, , catbin()
close #1
else
open targetdir + "catbinweights2.dat" for output as #1
put #1, , catbin()
close #1
end if

print "Bin score and user score saved. (Part 6 of 6)"
print
print "Done!"
sleep
system







function getRMSE(byval id1 as uinteger, byval id2 as uinteger) as integer
dim matches as uinteger, SSE as uinteger
dim i as uinteger, j as uinteger, RMSE_old as uinteger
dim tempm as single,  temps as integer

matches = 0
j = user_moviesratedend(id2-1)+1
for i = user_moviesratedend(id1-1) + 1 to user_moviesratedend(id1)
if user_moviesratedscore(i) <> 1 then continue for
do
if j = user_moviesratedend(id2) then exit do
if user_moviesrated(i) = user_moviesrated(j) then
matches+=1
'temps = user_moviesratedscore(i) - user_moviesratedscore(j)
'SSE += temps*temps
if user_moviesratedscore(j) <> 1 then SSE+=25
exit do
end if
if user_moviesrated(i) > user_moviesrated(j) then j+=1 else exit do
loop
next i
if matches < 1 then getRMSE = 2147483647: exit function
tempm = sqr(SSE/matches)
'tempm = sqr(SSE/(log(matches+1)/log2))
getRMSE = tempm*1000
end function




function getRMSE2(byval id1 as uinteger, byval id2 as uinteger) as uinteger
dim as integer curmovie, binrating
'player movies are identified by: user_moviesratedend(id1), user_moviesrated()
'bin movies are identified by: binscore(id2, 1 to 17770)


dim matches as uinteger, SSE as uinteger
dim i as uinteger, j as uinteger, RMSE_old as uinteger
dim tempm as single
dim temps as integer

'is the user's movie in binscore()?
for i = user_moviesratedend(id1-1) + 1 to user_moviesratedend(id1)
if user_moviesratedscore(i) <> 1 then continue for
curmovie = user_moviesrated(i)
binrating = binscore(id2, curmovie)
if binrating <> 0 then
'temps = user_moviesratedscore(i) - binrating
'SSE += temps*temps
if binrating <> 1 then SSE += 25
matches+=1
end if
next i


if matches < 1 then getRMSE2 = 4294967295: exit function
tempm = SQR(SSE/matches)
getRMSE2 = tempm*1000
end function



function existsinarray(ats() as ushort, byref value as ushort, byval first as integer, byval last as integer) as integer
dim as integer mid1, low, high
low = first
high = last - 1
do while (low <= high)
mid1 = (low + high) / 2
if (ats(mid1) > value) then
high = mid1 - 1
elseif (ats(mid1) < value) then
low = mid1 + 1
else
existsinarray = mid1: exit function
end if
loop
existsinarray = -1
end function



function qpartition_linkedi(array1() as uinteger, array2() as uinteger, theleft as integer, theright as integer, pivotIndex as integer) as integer
dim pivotValue as typeof(array1)
dim as integer i, storeindex
pivotValue = array1(pivotIndex)
swap array1(pivotIndex), array1(theright) ' Move pivot to end
swap array2(pivotIndex), array2(theright)
storeIndex = theleft
for i = theleft to theright-1
if array1(i) <= pivotValue then
swap array1(storeIndex), array1(i)
swap array2(storeIndex), array2(i)
storeIndex = storeIndex + 1
end if
next i
swap array1(theright), array1(storeIndex) ' Move pivot to its final place
swap array2(theright), array2(storeIndex)
qpartition_linkedi = storeIndex
end function


sub qsort_linkedi(array1() as uinteger, array2() as uinteger, byval theleft as integer, byval theright as integer, reverse_sort as integer)
dim temp1a as typeof(array1)
dim temp1b as typeof(array2)
dim as integer i, j, oldj, m, k, pivotamount, pivotindex, pivotnewindex, pbsize, therightmax, curpivot
dim as integer inileft, iniright
pbsize = (theright-theleft+1)'(ubound(array1) - lbound(array1) + 1)\2
dim pivotleft(0 to pbsize) as integer, pivotright(0 to pbsize) as integer
pivotamount = 0
i = 0
inileft = theleft
iniright = theright
pivotleft(0) = theleft
pivotright(0) = theright
therightmax = theright
j = 1
do
oldj = j
do
if curpivot > pivotamount then exit do
m = curpivot+i
if m > pbsize then m = m - pbsize
theleft = pivotleft(m)
theright = pivotright(m)
if theright >= theleft then
pivotIndex = (theright-theleft)\2+theleft' int(RND*(theright-theleft))+theleft
pivotNewIndex = qpartition_linkedi(array1(), array2(), theleft, theright, pivotIndex)
if j > pbsize then j = 0
pivotleft(j) = theleft: pivotright(j) = pivotNewIndex-1: j+=1
if j > pbsize then j = 0
pivotleft(j) = pivotNewIndex+1: pivotright(j) = theright: j+=1
k+=2
end if
curpivot+=1
loop
i = oldj
if i < 0 then i+=pbsize
pivotamount = k-1: k = 0
curpivot = 0
if pivotamount = -1 then exit do
loop

if reverse_sort = 1 then
for i = inileft to iniright \ 2
j = iniright - i + 1
swap array1(i), array1(j)
swap array2(i), array2(j)
next i
end if
end sub





sub qsort_linkedi2(array1() as uinteger, array2() as ubyte, byval theleft as integer, byval theright as integer, reverse_sort as integer, n as integer)
dim temp1a as typeof(array1)
dim temp1b as typeof(array2)
dim as integer i, j, oldj, newj, m, k, pivotamount, pivotindex, pivotnewindex, pbsize, therightmax, curpivot
dim as integer inileft, iniright
dim pivotValue as typeof(array1)
pbsize = (theright-theleft+1)
dim pivotleft(0 to pbsize) as integer, pivotright(0 to pbsize) as integer
pivotamount = 0
i = 0
inileft = theleft
iniright = theright
pivotleft(0) = theleft
pivotright(0) = theright
therightmax = theright
j = 1
do
oldj = j
do
if curpivot > pivotamount then exit do
m = curpivot+newj
if m > pbsize then m = m - pbsize
theleft = pivotleft(m)
theright = pivotright(m)
if theright >= theleft then
pivotIndex = (theright-theleft)\2+theleft
pivotValue = array1(n, pivotIndex)
swap array1(n, pivotIndex), array1(n, theright) ' Move pivot to end
swap array2(pivotIndex), array2(theright)
pivotNewIndex = theleft
for i = theleft to theright-1
if array1(n, i) <= pivotValue then
swap array1(n, pivotNewIndex), array1(n, i)
swap array2(pivotNewIndex), array2(i)
pivotNewIndex = pivotNewIndex + 1
end if
next i
swap array1(n, theright), array1(n, pivotNewIndex) ' Move pivot to its final place
swap array2(theright), array2(pivotNewIndex)
if j > pbsize then j = 0
pivotleft(j) = theleft: pivotright(j) = pivotNewIndex-1: j+=1
if j > pbsize then j = 0
pivotleft(j) = pivotNewIndex+1: pivotright(j) = theright: j+=1
k+=2
end if
curpivot+=1
loop
newj = oldj
if newj < 0 then newj+=pbsize
pivotamount = k-1: k = 0
curpivot = 0
if pivotamount = -1 then exit do
loop

if reverse_sort = 1 then
for i = inileft to iniright \ 2
j = iniright - i + 1
swap array1(n, i), array1(n, j)
swap array2(i), array2(j)
next i
end if
end sub





sub adjustcats(n as integer)
dim as integer curbin, curscore, curuser, curmovie, curmatches, i, j
if n <> 1 then
binsize = uniqueuseramount/4
redim catbin(1 to totbins, 1 to binsize) as uinteger
else
end if
dim commontot(1 to movieamount, 1 to 5) as uinteger
open targetdir + "catbinweights"+ltrim$(str$(n))+".dat" for binary as #1
get #1, , catbin()
close #1

end sub



