#include once "vbcompat.bi"
#include "qsort.bi"
const newLine = chr(10) 
dim as integer minDate = dateserial(1998, 10, 1)
dim as uinteger userIDmin = 1, userIDmax = 2649429
dim as uinteger userAmount = 480189
dim as uinteger movieAmount = 17770
dim as uinteger ratingAmount
dim as string dataDir = "data/"
if fileExists(dataDir+"ratingmovie.dat") then ratingAmount = fileLen(dataDir+"ratingmovie.dat") else ratingAmount = 1
dim as uinteger movieStart(0 to movieAmount)
dim as uinteger userStart(0 to userAmount)
redim as uinteger userId(0 to ratingAmount-1)
redim as ushort movieId(0 to ratingAmount-1)
redim as ushort sDate(0 to ratingAmount-1)
redim as ubyte ratingMovie(0 to ratingAmount-1)
redim as ubyte ratingUser(0 to ratingAmount-1)
dim as string tempS1, tempS2
dim as integer i, j, k, m, n, o, v, c

#macro loadDataMake(customType)
declare sub loadData overload(byref fileName as string, arrayToLoad() as customType)
sub loadData(byref fileName as string, arrayToLoad() as customType)
 dim as integer f = freefile()
 open fileName for binary as #f
 get #f, 1, arrayToLoad()
 close #f
end sub
#endmacro

#macro saveDataMake(customType)
declare sub saveData overload(byref fileName as string, arrayToSave() as customType)
sub saveData(byref fileName as string, arrayToSave() as customType)
 dim as integer f = freefile()
 open fileName for output as #f
 put #f, 1, arrayToSave()
 close #f
end sub
#endmacro


#macro binarySearchMake(mainType)
declare function binarySearch overload(ats() as mainType, byval vtf as mainType, byval a as integer, byval b as integer, byref success as ubyte) as integer
function binarySearch(ats() as mainType, byval vtf as mainType, byval a as integer, byval b as integer, byref success as ubyte) as integer
 dim n as uinteger
' for n = a to b
' print #1, ats(n)
' next n
'sleep
'system
 do
 if a > b then success = 0: exit function
 n = (a + b) / 2
 if vtf = ats(n) then binarySearch = n: success = 1: exit function
 if vtf < ats(n) then
  b = n - 1
 else
  a = n + 1
 end if
loop
end function
#endmacro

loadDataMake(double)
loadDataMake(single)
loadDataMake(uinteger)
loadDataMake(integer)
loadDataMake(ushort)
loadDataMake(short)
loadDataMake(ubyte)
loadDataMake(byte)
saveDataMake(double)
saveDataMake(single)
saveDataMake(uinteger)
saveDataMake(integer)
saveDataMake(ushort)
saveDataMake(short)
saveDataMake(ubyte)
saveDataMake(byte)


qsortDefineLinked(low, uinteger, ubyte)
qsortDefineLinked(high, uinteger, ushort)
qsortDefineLinked(low, single, ushort)
qsortDefine(low, short)

binarySearchMake(ushort)
binarySearchMake(uinteger)