declare function partition_linkedi(array1() as integer, array2() as integer, theleft as integer, theright as integer, pivotIndex as integer) as integer
declare sub qsort_linkedi(array1() as integer, array2() as integer, byval theleft as integer, byval theright as integer, reverse_sort as integer)

cls
dim as integer i, j, k, currating, toterr2
dim as integer testmovie_end2, testmovie, curmovie, curuserid
dim as string tempst, targetdir, command2
dim as integer findtestamounts
dim shared as integer testmovie_amount, testrating_amount
dim shared as integer movieamount, uniqueuseramount, scoreamount
dim as single hightest, lowtest, toterr
dim as single bestRMSE, rmse
dim as integer bestRMSEj
dim as integer usefudge: usefudge = 0
dim ms2(0 to 4) as integer, ms2b(0 to 4) as integer
dim avgrat(1 to 5) as single, avgrattot(1 to 5) as single
movieamount = 17770
uniqueuseramount = 480189
scoreamount = 100480507

targetdir = "C:\testnetflix\dataset\"
'load in the weights...
dim shared newline as string * 1: newline = CHR$(13)  
dim shared ex1 as integer
dim shared totbins as integer
command2 = command$
if command2 = "" then command2 = "weights"
open targetdir + command2 + ".dat" for binary as #1
get #1, , totbins
print totbins
dim shared binscore(1 to totbins, 1 to movieamount) as ubyte
dim shared userRMSE(1 to uniqueuseramount, 1 to totbins) as uinteger
get #1, , binscore()
if usefudge = 0 then get #1, , userRMSE()
close #1


'construct a shortuserid...
dim shared shortuserid2(1 to 2649429) as uinteger
open targetdir + "shortuserids2.dat" for binary as #1: get #1, , shortuserid2(): close #1


open "probe.dat" for binary as #1
get #1, , testmovie_amount
get #1, , testrating_amount
dim shared actual_rating(1 to testrating_amount) as ubyte
dim shared testmovie_end(0 to testmovie_amount) as uinteger
dim shared testmovie_id(1 to testmovie_amount+1) as uinteger
dim shared testuser_id(1 to testrating_amount) as uinteger
get #1, , testmovie_end()
get #1, , testmovie_id()
get #1, , testuser_id()
get #1, , actual_rating()
close #1

dim shared user_averagerating(1 to uniqueuseramount) as uinteger
dim shared movie_averagerating(1 to movieamount) as uinteger
dim shared user_moviesratedamount(0 to uniqueuseramount) as uinteger
open targetdir + "statistics.dat" for binary as #1
get #1, , user_moviesratedamount()
get #1, , user_averagerating()
get #1, , movie_averagerating()
close #1

'get the actual results...

open targetdir + "movieend.dat" for binary as #1
dim shared movieend(0 to movieamount) as uinteger: get #1, 1, movieend(): close: print "Movie sizes have been loaded."
'for i = 1 to movieamount
'if movieend(i) - movieend(i-1)+1 < 20 then print i
'next i
'sleep
'system
dim shared swapn(1 to uniqueuseramount, 1 to totbins, 1 to 5) as ushort
dim shared userRMSE2(1 to uniqueuseramount, 1 to totbins, 1 to 5) as ushort

'userRMSE2 can be 10 16 bit integers per user: 480,189*10*2 bytes = 9603780
'swapn can be 10 16 bit integers per user: 480,189*10*2 bytes = 9603780
'binscore can be 2 16 bit integers per movie 17770*2*2 bytes = 71080
'total: 19,278,640 bytes per user: 18.4 megs!

'if usefudge = 1 then
'dim shared swapn(0, 0, 0) as ushort
'dim shared userRMSE2(0, 0, 0) as short
'redim swapn(1 to uniqueuseramount, 1 to totbins, 1 to 5)
'redim userRMSE2(1 to uniqueuseramount, 1 to totbins, 1 to 5)
if usefudge = 1 then
open targetdir + "swapn2.dat" for binary as #1
get #1, , swapn()
get #1, , userRMSE2()
get #1, , userRMSE()
close #1
end if

if usefudge = 2 then
open targetdir + "swapn3.dat" for binary as #1
get #1, , swapn()
get #1, , userRMSE()
close #1
end if
'for i = 1 to 5
'print userRMSE2(1, 1, i)
'next i

'system
'end if
print "Verification values have been loaded."

dim shared misses(1 to 5, 1 to 5) as uinteger
dim shared total(1 to 5, 1 to 2) as uinteger

dim shared catimportance as single, totRMSE as single
dim shared testrating as single, curRMSE as uinteger
dim shared scoreRMSE(1 to totbins) as single, totcat1 as single, totcat2 as single
dim existsRMSE1(1 to totbins) as integer
dim existsRMSE2(1 to totbins) as integer
dim temps as single, temps2 as single
dim shared ms as single
dim shared curmovie2 as integer, curuser as integer, matches as integer
dim shared as integer curscore, curmovieamount, tempvar, outputerrors
dim shared as integer e1, e2, e3, e4, lentemp


'dim curmovieid as integer
'Get the ratings and the RMSE!
curmovie2 = 1: curmovie = testmovie_id(curmovie2)

dim shared errorbysize1(1 to 17770) as uinteger
dim shared errorbysize2(1 to 17770) as uinteger
dim shared errorbyrating1(0 to 500) as uinteger
dim shared errorbyrating2(0 to 500) as uinteger
dim testrating_amount2 as uinteger
for i = 1 to testrating_amount'\10
curuser = shortuserid2(testuser_id(i))
testrating = 0
matches = 0
bestRMSE = 4294967295

if usefudge = 1 then

for j = 1 to totbins
curscore = binscore(j, curmovie)
if curscore = 0 then continue for
'curRMSE = userRMSE2(curuser, j, curscore)
curRMSE = userRMSE(curuser, j)
if curRMSE = 4294967295 then continue for
curscore = swapn(curuser, j, curscore)
if curRMSE < bestRMSE then bestRMSE = curRMSE: bestRMSEj = j
matches += 1
next j
if matches < 1 then
testrating = 4
else
testrating = binscore(bestRMSEj, curmovie)
testrating = swapn(curuser, bestRMSEj, testrating)
end if

elseif usefudge = 2 then


for j = 1 to totbins
curscore = binscore(j, curmovie)
if curscore = 0 then continue for
curRMSE = userRMSE2(curuser, j, curscore)
'curRMSE = userRMSE(curuser, j)
if curRMSE = 4294967295 then continue for
curscore = swapn(curuser, j, curscore)
if curRMSE < bestRMSE then bestRMSE = curRMSE: bestRMSEj = j
matches += 1
next j
if matches < 1 then
testrating = 4
else
testrating = binscore(bestRMSEj, curmovie)
testrating = swapn(curuser, bestRMSEj, testrating)
end if

else

'if actual_rating(i) = 1 then
'if userRMSE(curuser, 1) = 2147483647 then system'goto a1
if userRMSE(curuser, 1) = 4294967295 then goto a1

avgrat(actual_rating(i)) += userRMSE(curuser,1)
avgrattot(actual_rating(i)) +=1
'for j = 1 to 64
'print userRMSE(curuser,j)
'next j
'end if
'select case userRMSE(curuser, j)
'case < 1650
testrating = 1
'sleep
'system
'testrating = 0
'toterr = 0
'for j = 1 to totbins
'curscore = binscore(j, curmovie)
'if curscore = 0 then continue for
'curRMSE = userRMSE(curuser, j)
'if curRMSE = 2147483647 then system'continue for
'if curRMSE < bestRMSE then bestRMSE = curRMSE: bestRMSEj = j
'matches += 1
'if curRMSE > 2500 then tempvar = 0 else tempvar = ((6250000-curRMSE^2)/10000)^2/100
'testrating+= curscore*tempvar
'toterr+= tempvar
'next j

'if matches < 1 then
'goto a1
'testrating = 4
'else
'if userRMSE(curuser, bestRMSEj) > 800 then goto a1
'testrating = binscore(bestRMSEj, curmovie)
'testrating = testrating / toterr
end if

'for j = 1 to totbins
'curscore = binscore(j, curmovie)
'if curscore = 0 then continue for
'curRMSE = userRMSE(curuser, j)
'if curRMSE = 4294967295 then continue for
'if curRMSE < bestRMSE then bestRMSE = curRMSE: bestRMSEj = j
'matches += 1
'next j
'if matches < 1 then
'testrating = 4
'else
'testrating = binscore(bestRMSEj, curmovie)
'end if

'print curuser, curmovie, testrating
'sleep
'system
'if bestRMSE > 800 then goto a1
'if testrating = 1 then goto a1
'if actual_rating(i) = 1 then goto a1
'if testrating <> 5 then goto a1
'if ex1<100 then
'if actual_rating(i) = 1 then
'if testrating <> 1 and actual_rating(i) = 1 then
'if testrating <> 1 and actual_rating(i) = 1 then 
'print curuser;" "; bestRMSE;" ";user_moviesratedamount(curuser);" ";curmovie;" "; matches;" "; user_averagerating(curuser); " ";movie_averagerating(curmovie); testrating;" ";actual_rating(i)
'ex1+=1
'end if
'else
'for i = 1 to 5
'print 1000*avgrat(i)/avgrattot(i)
'next i
'system
'end if
'end if
'end if

if testrating>5 then testrating = 5
if testrating<1 then testrating = 1
tempvar = abs(testrating - actual_rating(i)): ms += tempvar*tempvar

'print tempvar; testrating;" ";actual_rating(i)
'print "hi"

ms2(tempvar)+=tempvar*tempvar
ms2b(tempvar)+=tempvar
misses(testrating, actual_rating(i)) +=1
total(actual_rating(i), 1) +=1
total(testrating, 2) +=1
testrating_amount2+=1

curmovieamount = user_moviesratedamount(curuser)
errorbysize1(curmovieamount)+=1
errorbysize2(curmovieamount)+=tempvar*tempvar
errorbyrating1(testrating*100)+=1
errorbyrating2(testrating*100)+=tempvar*tempvar

a1:
if i = testmovie_end(curmovie2) then curmovie2+=1: curmovie = testmovie_id(curmovie2)
next i


outputerrors = 1
if outputerrors = 1 then
open targetdir + "errorbyrating.txt" for output as #1
for i = 0 to 500
if errorbyrating1(i)<>0 then
e3 = 100*sqr(errorbyrating2(i)/errorbyrating1(i))
print #1, errorbyrating1(i), errorbyrating2(i), e3, i
end if
next i
close #1

open targetdir + "errorbysize.txt" for output as #1
for i = 1 to 17770
if errorbysize1(i) <> 0 then
e1 = errorbysize1(i)
e2 = errorbysize2(i)
e3 = 100 * sqr(errorbysize2(i)/errorbysize1(i))
e4 = i
print #1, errorbysize1(i),errorbysize2(i),e3, e4
end if
next i
close #1
end if

for i = 1 to 5
print avgrat(i), avgrattot(i), avgrat(i)/avgrattot(i)
next i


'calculate RMSE...
rmse = sqr(ms / testrating_amount2)

'Format/print the results...
print
print rmse;" "; ms;" "; testrating_amount2
print total(actual_rating(1), 1)
for i = 0 to 4
print ms2(i), ms2b(i)
next i

for i = 1 to 5
tempst = ltrim$(str$(total(i, 2)))
lentemp = len(tempst)
print string$(7-lentemp, "0")+tempst+" ";
for j = 1 to 5
tempst = ltrim$(str$(misses(i, j)))
lentemp = len(tempst)
print string$(7-lentemp, "0")+tempst+" ";
next j
print
next i

sleep
system

print "0000000 ";
for i = 1 to 5
tempst = ltrim$(str$(total(i, 1)))
lentemp = len(tempst)
print string$(7-lentemp, "0")+tempst+" ";
next i
print
print
for i = 1 to 5
tempst = ltrim$(str$(total(i, 2)))
lentemp = len(tempst)
print string$(7-lentemp, "0")+tempst+" ";
for j = 1 to 5
tempst = ltrim$(str$(int(1000*misses(i, j)/total(i,2))))
lentemp = len(tempst)
print string$(7-lentemp, "0")+tempst+" ";
next j
print
next i
print "0000000 ";
for i = 1 to 5
tempst = ltrim$(str$(total(i, 1)))
lentemp = len(tempst)
print string$(7-lentemp, "0")+tempst+" ";
next i
print


system










function qpartition_linkedi(array1() as integer, array2() as integer, theleft as integer, theright as integer, pivotIndex as integer) as integer
dim pivotValue as typeof(array1)
dim as integer i, storeindex
pivotValue = array1(pivotIndex)
swap array1(pivotIndex), array1(theright) ' Move pivot to end
swap array2(pivotIndex), array2(theright)
storeIndex = theleft
for i = theleft to theright-1
if array1(i) <= pivotValue then
swap array1(storeIndex), array1(i)
swap array2(storeIndex), array2(i)
storeIndex = storeIndex + 1
end if
next i
swap array1(theright), array1(storeIndex) ' Move pivot to its final place
swap array2(theright), array2(storeIndex)
qpartition_linkedi = storeIndex
end function


sub qsort_linkedi(array1() as integer, array2() as integer, byval theleft as integer, byval theright as integer, reverse_sort as integer)
dim temp1a as typeof(array1)
dim temp1b as typeof(array2)
dim as integer i, j, oldj, m, k, pivotamount, pivotindex, pivotnewindex, pbsize, therightmax, curpivot
dim as integer inileft, iniright
pbsize = (ubound(array1) - lbound(array1) + 1)
dim pivotleft(0 to pbsize) as integer, pivotright(0 to pbsize) as integer
pivotamount = 0
i = 0
inileft = theleft
iniright = theright
pivotleft(0) = theleft
pivotright(0) = theright
therightmax = theright
j = 1
do
oldj = j
do
if curpivot > pivotamount then exit do
m = curpivot+i
if m > pbsize then m = m - pbsize
theleft = pivotleft(m)
theright = pivotright(m)
if theright >= theleft then
pivotIndex = (theright-theleft)\2+theleft' int(RND*(theright-theleft))+theleft
pivotNewIndex = qpartition_linkedi(array1(), array2(), theleft, theright, pivotIndex)
if j > pbsize then j = 0
pivotleft(j) = theleft: pivotright(j) = pivotNewIndex-1: j+=1
if j > pbsize then j = 0
pivotleft(j) = pivotNewIndex+1: pivotright(j) = theright: j+=1
k+=2
end if
curpivot+=1
loop
i = oldj
if i < 0 then i+=pbsize
pivotamount = k-1: k = 0
curpivot = 0
if pivotamount = -1 then exit do
loop


if reverse_sort = 1 then
for i = inileft to iniright \ 2
j = iniright - i + 1
swap array1(i), array1(j)
swap array2(i), array2(j)
next i
end if
end sub
